import { InjectionKey, ModelRef, UnwrapNestedRefs } from 'vue';
import { Store as DefineStore } from '../../../core/utils/store';
import { Props, Store } from './types';
export declare const injectionKey: InjectionKey<Store>;
/**
 * Инициировать Store компонента
 */
export declare const defineTabsStore: (props: Props, model: ModelRef<string | undefined>) => UnwrapNestedRefs<Store> & DefineStore;
/**
 * Получить Store компонента
 */
export declare const useTabsStore: () => Store & DefineStore;
