import { Core as be } from "../core/app.js";
import { defineComponent as P, mergeModels as N, useModel as D, computed as E, createElementBlock as B, openBlock as k, createBlock as b, unref as y, withCtx as _, Fragment as Y, renderList as se, normalizeClass as X, createElementVNode as he, toDisplayString as K, createVNode as A, createTextVNode as G, ref as F, watch as w, createCommentVNode as q, withModifiers as z, mergeProps as Se, withKeys as de, nextTick as Ve, resolveDirective as Ee, withDirectives as Me, resolveDynamicComponent as Ke, renderSlot as $e, shallowRef as we, createSlots as Le, reactive as Ae, toValue as ce, isRef as ge } from "vue";
import { u as R, C as J, _ as H, y as ie, d as Re } from "../.chunks/forms-C-fyoosd.es.js";
import { _ as Ie, a as ue, b as Oe } from "../.chunks/listItem.vue_vue_type_script_setup_true_lang-BJTTvdc7.es.js";
import { _ as Ne } from "../.chunks/menu.vue_vue_type_style_index_0_lang-Bi9Z81pC.es.js";
import { u as De } from "../.chunks/utils-DsICGMuv.es.js";
import { getSearcherGIcon as Fe, getLangLabel as qe, getDeviceGIcon as Pe } from "../utils/searchers.js";
import { storage as W } from "../utils/dom.js";
import { TopPopupWorker as Ue } from "../popup/worker.js";
const Be = ["../assets/project.css"].map((t) => import.meta.resolve(t));
be.insertCSSLinkToPage(Be, !0);
const je = { class: "top-selectorCompetitors" }, ze = { class: "top-ellipsis1" }, Je = /* @__PURE__ */ P({
  __name: "selectorCompetitors",
  props: /* @__PURE__ */ N({
    modelValue: {},
    items: {},
    showSelectAllItem: { type: Boolean, default: !0 }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(t) {
    const a = t, o = D(t, "modelValue"), e = E(() => {
      if (a.showSelectAllItem)
        return {
          icon: "",
          title: R().Common.Select_all,
          value: "all",
          content: ""
        };
    });
    return (i, l) => (k(), B("div", je, [
      y(J).state.isMobile ? (k(), b(Ie, { key: 0 }, {
        opener: _(() => [
          A(H, {
            class: "top-selectorCompetitors_opener",
            color: "theme",
            icon: "",
            icon2: ""
          }, {
            default: _(() => {
              var n;
              return [
                G(K((n = i.items.find((u) => {
                  var f;
                  return u.value === ((f = o.value) == null ? void 0 : f[0]);
                })) == null ? void 0 : n.content), 1)
              ];
            }),
            _: 1
          })
        ]),
        contentList: _(() => [
          (k(!0), B(Y, null, se(i.items, (n) => {
            var u;
            return k(), b(ue, {
              class: X({
                "top-active": (u = o.value) == null ? void 0 : u.includes(n.value)
              }),
              "data-top-icon": n.icon,
              title: n.title,
              onClick: () => o.value = [n.value]
            }, {
              default: _(() => [
                he("span", ze, K(n.content), 1)
              ]),
              _: 2
            }, 1032, ["class", "data-top-icon", "title", "onClick"]);
          }), 256))
        ]),
        _: 1
      })) : (k(), b(Ne, {
        key: 1,
        modelValue: o.value,
        "onUpdate:modelValue": l[0] || (l[0] = (n) => o.value = n),
        items: i.items,
        isMultiple: !0,
        styling: "bar",
        canBeEmptyMultiple: !1,
        selectAllItem: e.value
      }, null, 8, ["modelValue", "items", "selectAllItem"]))
    ]));
  }
}), M = -1, p = -2, te = -1, Ge = {
  0: "Yandex",
  1: "Google",
  4: "YouTube",
  5: "Bing",
  7: "Seznam",
  8: "AppStore",
  9: "GoogleStore",
  20: "Yandex.com",
  21: "Yandex.com.tr"
}, me = {
  key: p,
  name: "--",
  index: p
}, xe = {
  key: p,
  name: "--",
  regions: [me],
  regionByIndex: /* @__PURE__ */ new Map([[p, me]])
}, le = {
  key: p,
  name: "Autoselect",
  index: p
}, re = {
  key: p,
  name: "Autoselect",
  regions: [le],
  regionByIndex: /* @__PURE__ */ new Map([[p, le]])
}, fe = {
  countryCode: "00",
  depth: 1,
  device: 0,
  key: te,
  index: te,
  lang: "ru",
  name: "Without region"
}, We = () => (le.name = R().Common.Autoselect, le), Ye = () => (We(), re.name = R().Common.Autoselect, console.log(re), re), He = () => (fe.name = R().Keywords.Without_region, fe), ke = (t = !1, a = !1, o = []) => {
  let e;
  return t ? e = Qe(o) : e = Ce(o), a && e.set(p, Ye()), e.size || e.set(p, xe), e;
}, Ce = (t, a = !0, o = [], e = !1) => {
  const i = /* @__PURE__ */ new Map();
  return t.forEach((l) => {
    if (!l.enabled || e && typeof l.key == "number" && l.key > 1) return;
    const n = { ...l };
    n.regionByIndex = /* @__PURE__ */ new Map(), l.regions && l.regions.forEach((u) => {
      if (a && !u.enabled) return;
      const f = { ...u };
      n.regionByIndex.set(f.index, f);
    }), !n.regionByIndex.size && o.length, // режим вывода ПС без регионов
    (!l.regions || // есть включенные регионы
    n.regionByIndex.size || // запрошен вывод конкретных ПС
    o.length) && typeof n.key == "number" && i.set(n.key, n);
  }), o.forEach((l) => {
    if (i.has(l)) return;
    const n = {
      key: l,
      name: Ge[l],
      regions: [],
      regionByIndex: /* @__PURE__ */ new Map()
    };
    i.set(n.key, n);
  }), i;
}, Qe = (t) => {
  const a = Ce(t, !1, [0, 1], !0);
  if (a.has(2)) {
    const o = a.get(2);
    o && (o.regionByIndex = /* @__PURE__ */ new Map());
  }
  return a.forEach((o) => {
    if (!o.regionByIndex) return;
    const e = { ...He() };
    o.regionByIndex.set(e.index, e);
  }), a;
}, Xe = (t, a, o = []) => {
  const e = ke(t, !1, o);
  let i;
  return e.forEach((l) => {
    if (!(a.searcher_key !== void 0 && a.searcher_key != l.key) && l.regions && (l.regions.forEach((n) => {
      if (!i && !(a.key !== void 0 && a.key != n.key) && !(a.index !== void 0 && a.index != n.index) && !(!t && (a.lang !== void 0 && a.lang != n.lang || a.device !== void 0 && a.device != n.device)))
        return n.searcher_key = l.key, i = n, !1;
    }), i))
      return !1;
  }), i;
}, Ze = De(() => import("../.chunks/dialog_selectorRegions-lYV2SJBx.es.js")), et = (t, a) => {
  const o = R(), e = F(a.value.keys().next().value ?? p), i = E(() => {
    const l = /* @__PURE__ */ new Map();
    if (a.value.forEach((n) => {
      let u = {
        value: n.key,
        title: n.name
      };
      t.addSearcherIcon && (u.icon = Fe(n.key)), l.set(n.key, u);
    }), t.addCompare && !l.has(p)) {
      const n = {
        value: "",
        title: "--------------------",
        disabled: !0
      };
      l.set(n.value, n);
      const u = {
        value: M,
        title: o.Common.Compare
      };
      l.set(u.value, u);
    }
    return l;
  });
  return {
    searcherKey: e,
    optionBySearcherKey: i
  };
}, tt = (t, a) => {
  var l, n, u;
  const o = R(), e = F(p);
  t.modelValue.length === 1 && (e.value = t.modelValue[0]), e.value === p && (t.forFrequency ? e.value = ((n = (l = a.value) == null ? void 0 : l.regionByIndex.values().next().value) == null ? void 0 : n.key) ?? p : e.value = ((u = a.value) == null ? void 0 : u.regionByIndex.keys().next().value) ?? p);
  const i = E(() => {
    var h;
    const f = /* @__PURE__ */ new Map();
    return (h = a.value.regionByIndex) == null || h.forEach((S) => {
      let r = S.name;
      if (t.forFrequency) {
        const x = {
          value: S.key,
          title: r
        };
        f.has(S.key) || f.set(S.key, x);
        return;
      }
      S.device && (r += " (" + o.Common["Device_" + S.device] + ")");
      const g = qe(a.value.key || 0, S.lang ?? "");
      g && (r += " / " + g);
      const d = {
        value: S.index,
        title: r,
        icon: S.device ? Pe(S.device) : void 0
      };
      f.set(S.index, d);
    }), f;
  });
  return w(i, (f, h) => {
    var d;
    if (t.onlySearcher || e.value !== void 0 && f.get(e.value))
      return;
    let S = f.keys().next().value;
    if (e.value === p || S === p) {
      e.value = S;
      return;
    }
    let r = ((d = h == null ? void 0 : h.get(e.value)) == null ? void 0 : d.title) || "", g = -1;
    for (const [x, T] of f.entries()) {
      const C = T.title;
      if (typeof C != "string" || typeof x == "string")
        break;
      if (C === r) {
        S = x;
        break;
      }
      const V = new RegExp(` \\((${o.Common.Device_1}|${o.Common.Device_2})\\)`);
      let m = r, s = 3;
      C.indexOf(m) === -1 && (m = r.replace(/^[^a-zа-я]/i, "").replace(V, ""), s--), C.indexOf(m) === -1 && (m = r.replace(/ \/.*/, ""), s--), C.indexOf(m) === -1 && (m = r.replace(/ \/.*/, ""), m = m.replace(/^[^a-zа-я]/i, "").replace(V, ""), s--), C.indexOf(m) !== -1 && (s <= g || (g = s, S = x));
    }
    e.value = S;
  }), {
    regionIndex: e,
    optionByRegionIndex: i
  };
}, lt = (t, a, o) => {
  const e = F([]), i = () => {
    if (t.onlySearcher && a.value) {
      e.value = Array.from(a.value.keys());
      return;
    }
    let n = [];
    if (t.modelValue.length > 1)
      n = [...t.modelValue];
    else
      try {
        n = JSON.parse(
          localStorage.getItem("ui:project:regionSelector" + t.projectId + ":regionsIndexes")
        ) ?? [];
      } catch {
      }
    n.length && (n = n.filter((u) => o.value.has(u))), n.length || (n = Array.from(o.value)), e.value = [...n];
  }, l = () => {
    e.value.length ? localStorage.setItem("ui:project:regionSelector:" + t.projectId + ":regionsIndexes", JSON.stringify(e.value)) : localStorage.removeItem("ui:project:regionSelector:" + t.projectId + ":regionsIndexes");
  };
  return w(e, () => {
    l();
  }), t.addCompare && i(), {
    regionsIndexes: e
  };
}, at = (t) => {
  const a = E(() => ke(t.forFrequency, t.autoRegion, t.searchers)), o = E(() => a.value.get(i.searcherKey.value) || xe), e = E(() => {
    const r = /* @__PURE__ */ new Set();
    return a.value.forEach((g) => {
      g.regionByIndex.forEach((d) => {
        d.index !== te && d.index !== p && r.add(d.index);
      });
    }), r;
  }), i = et(t, a), l = tt(t, o), n = lt(t, a, e);
  w(a, () => {
    var g, d, x, T;
    if (t.onlySearcher ? n.regionsIndexes.value = Array.from(a.value.keys()) : n.regionsIndexes.value = n.regionsIndexes.value.filter((C) => e.value.has(C)), i.searcherKey.value === M) return;
    let r = a.value.keys().next().value;
    a.value.forEach((C) => {
      var V, m, s;
      if (t.onlySearcher && C.key === i.searcherKey.value) {
        r = i.searcherKey.value;
        return;
      }
      if (l.regionIndex.value && ((V = C.regionByIndex) != null && V.has(l.regionIndex.value)) && (r = C.key), !t.onlySearcher) {
        let c;
        r !== void 0 && (c = (m = a.value.get(r)) == null ? void 0 : m.regionByIndex);
        const v = (s = a.value.get(C.key)) == null ? void 0 : s.regionByIndex;
        c != null && c.has(p) && !(v != null && v.has(p)) && (r = C.key);
      }
    }), r !== void 0 && (i.searcherKey.value = r), l.regionIndex.value !== void 0 && !((d = (g = o.value) == null ? void 0 : g.regionByIndex) != null && d.has(l.regionIndex.value)) && (l.regionIndex.value = (T = (x = o.value) == null ? void 0 : x.regions) == null ? void 0 : T.keys().next().value);
  }, { immediate: !0 });
  const u = () => {
    if (!(i.searcherKey.value === M || i.searcherKey.value === p))
      return i.searcherKey.value;
  }, f = () => {
    if (t.onlySearcher || l.regionIndex.value === p) return;
    let r = l.regionIndex.value;
    if (t.forFrequency) {
      const g = l.regionIndex.value, d = Xe(t.forFrequency, { searcher_key: u(), key: g }, t.searchers);
      r = d == null ? void 0 : d.index;
    }
    return r;
  }, h = () => {
    const r = u();
    if (r !== void 0)
      return a.value.get(r);
  };
  return {
    selectSearcher: i,
    selectRegion: l,
    compare: n,
    searcherByKey: a,
    allRegionsIndexes: e,
    getSearcher: h,
    getRegion: () => {
      var g, d;
      const r = f();
      if (r !== void 0)
        return (d = (g = h()) == null ? void 0 : g.regionByIndex) == null ? void 0 : d.get(r);
    }
  };
}, nt = /* @__PURE__ */ P({
  __name: "selectorRegion",
  props: /* @__PURE__ */ N({
    projectId: {},
    searchers: { default: () => [] },
    modelValue: {},
    modelValueSingle: {},
    addCompare: { type: Boolean },
    forFrequency: { type: Boolean },
    autoRegion: { type: Boolean },
    onlySearcher: { type: Boolean },
    addChanger: { type: Boolean, default: !0 },
    addSearcherIcon: { type: Boolean, default: !0 },
    addRegionIcon: { type: Boolean, default: !0 }
  }, {
    modelValue: { required: !0 },
    modelModifiers: {},
    modelValueSingle: {},
    modelValueSingleModifiers: {}
  }),
  emits: ["update:modelValue", "update:modelValueSingle"],
  setup(t, { expose: a }) {
    const o = t, e = D(t, "modelValue"), i = D(t, "modelValueSingle"), {
      selectSearcher: l,
      selectRegion: n,
      compare: u,
      searcherByKey: f,
      allRegionsIndexes: h,
      getSearcher: S,
      getRegion: r
    } = at(o), g = () => {
      const d = [];
      f.value.forEach((x) => {
        x.enabled && x.regions.forEach((T) => {
          T.enabled && d.push(T);
        });
      }), Ze.open("selectorRegions", {
        regions: d,
        regionsIndexes: u.regionsIndexes.value,
        "@update:regionsIndexes": (x) => u.regionsIndexes.value = x
      });
    };
    return w([n.regionIndex, l.searcherKey, u.regionsIndexes], () => {
      if (l.searcherKey.value === M && u.regionsIndexes.value.length) {
        if (JSON.stringify(e.value) === JSON.stringify(u.regionsIndexes.value))
          return;
        e.value = [...u.regionsIndexes.value];
      } else
        o.onlySearcher ? (e.value = [l.searcherKey.value], l.searcherKey.value === p && !o.autoRegion && (e.value.length = 0)) : (e.value = [n.regionIndex.value], n.regionIndex.value === p && !o.autoRegion && (e.value.length = 0));
      !o.onlySearcher && !h.value.size && (l.searcherKey.value = p);
    }), i.value && w(i, () => {
      i.value && (e.value = [i.value]);
    }, { immediate: !0 }), w(e, () => {
      var d, x, T, C, V;
      if (e.value[0] && (i.value = e.value[0]), o.onlySearcher) {
        if (!e.value.length || e.value.length === 1 && !f.value.has(e.value[0]) || e.value.length === 1 && e.value[0] === p && !o.autoRegion) {
          let m = f.value.keys().next().value;
          m === p && !o.autoRegion && (m = void 0, i.value = p), m !== void 0 ? e.value = [m] : e.value.length = 0;
          return;
        }
        if (e.value.length > 1 && JSON.stringify(e.value) !== JSON.stringify(u.regionsIndexes.value)) {
          e.value = [...u.regionsIndexes.value];
          return;
        }
      } else {
        let m = [...new Set(e.value)], s = (x = (d = f.value.values().next().value) == null ? void 0 : d.regionByIndex) == null ? void 0 : x.keys().next().value;
        if (o.forFrequency && (s = (V = (C = (T = f.value.values().next().value) == null ? void 0 : T.regionByIndex) == null ? void 0 : C.values().next().value) == null ? void 0 : V.key), s === p && !o.autoRegion && (s = void 0, i.value = p), !m.length)
          s !== void 0 && m.push(s);
        else if (m.length === 1) {
          let c = h.value;
          o.forFrequency && (c = /* @__PURE__ */ new Set(), f.value.forEach((v) => {
            v.regionByIndex.forEach((I) => {
              I.index !== te && I.index !== p && c.add(I.key);
            });
          })), c.has(m[0]) || (m = [], s !== void 0 && m.push(s));
        } else
          m = m.filter((c) => h.value.has(c)), !m.length && s !== void 0 && m.push(s);
        if (JSON.stringify(e.value) !== JSON.stringify(m)) {
          e.value = m;
          return;
        }
      }
      if (!(e.value.length === 1 && e.value[0] === (o.onlySearcher ? l.searcherKey.value : n.regionIndex.value)))
        if (o.onlySearcher) {
          if (e.value.length === 1) {
            l.searcherKey.value = e.value[0];
            return;
          }
          l.searcherKey.value = M;
          return;
        } else {
          if (!e.value.length)
            return;
          if (e.value.length === 1 && l.searcherKey.value !== M) {
            n.regionIndex.value = e.value[0];
            let m;
            for (const s of f.value.values()) {
              for (const c of s.regionByIndex.values())
                if ((o.forFrequency ? c.key : c.index) === n.regionIndex.value) {
                  m = s.key;
                  break;
                }
              if (m !== void 0)
                break;
            }
            m !== void 0 && (l.searcherKey.value = m);
          } else
            l.searcherKey.value = M, u.regionsIndexes.value = [...e.value];
        }
    }, { immediate: !0 }), a({
      getSearcher: S,
      getRegion: r
    }), (d, x) => (k(), B("div", {
      class: X({
        "top-selectorRegion": !0,
        "top-selectorRegion-onlySearcher": d.onlySearcher
      })
    }, [
      A(ie, {
        options: y(l).optionBySearcherKey.value,
        modelValue: y(l).searcherKey.value,
        "onUpdate:modelValue": x[0] || (x[0] = (T) => y(l).searcherKey.value = T),
        name: "searcher_key",
        addChanger: d.addChanger
      }, null, 8, ["options", "modelValue", "addChanger"]),
      !d.onlySearcher && y(l).searcherKey.value !== y(M) ? (k(), b(ie, {
        key: 0,
        class: "top-select-region",
        options: y(n).optionByRegionIndex.value,
        modelValue: y(n).regionIndex.value,
        "onUpdate:modelValue": x[1] || (x[1] = (T) => y(n).regionIndex.value = T),
        name: d.forFrequency ? "region_key" : "region_index",
        addChanger: d.addChanger,
        "data-top-icon": d.addRegionIcon ? "" : void 0
      }, null, 8, ["options", "modelValue", "name", "addChanger", "data-top-icon"])) : q("", !0),
      d.addCompare && !d.onlySearcher && y(l).searcherKey.value === y(M) ? (k(), b(H, {
        key: 1,
        name: "compare",
        onClick: g,
        "data-count-compare-regions-indexes": y(u).regionsIndexes.value.length
      }, {
        default: _(() => [
          G(K(d.$i18n.Common.Selected_regions), 1)
        ]),
        _: 1
      }, 8, ["data-count-compare-regions-indexes"])) : q("", !0)
    ], 2));
  }
}), ot = [
  {
    id: "1",
    name: "Without Tag",
    color_id: "1"
  },
  {
    id: "2",
    name: "Red",
    color_id: "2"
  },
  {
    id: "3",
    name: "Orange",
    color_id: "3"
  },
  {
    id: "4",
    name: "Yellow",
    color_id: "4"
  },
  {
    id: "5",
    name: "Blue",
    color_id: "5"
  },
  {
    id: "6",
    name: "Purple",
    color_id: "6"
  },
  {
    id: "7",
    name: "Green",
    color_id: "7"
  },
  {
    id: "8",
    name: "Magenta",
    color_id: "8"
  },
  {
    id: "9",
    name: "Dark blue",
    color_id: "9"
  },
  {
    id: "10",
    name: "Turquoise",
    color_id: "10"
  }
], ve = (t) => "-" + t, Q = (t) => t[0] === "-" ? t.substring(1) : t, ae = (t, a) => {
  t = Q(t);
  const o = a.find((e) => e.id === t);
  if (o)
    return o;
}, rt = ["data-tag_id", "data-tag_color_id", "title"], ne = /* @__PURE__ */ P({
  __name: "tagIcon",
  props: {
    id: {},
    colorId: {},
    name: {},
    state: {}
  },
  setup(t) {
    return (a, o) => (k(), B("div", {
      class: X({
        "top-tagSelector_tagIcon": !0,
        "top-tagSelector-active": !!a.state,
        "top-tagSelector-excluded": a.state === "excluded"
      }),
      "data-tag_id": a.id,
      "data-tag_color_id": a.colorId,
      title: a.name
    }, null, 10, rt));
  }
}), it = ["contenteditable", "onKeydown"], ye = /* @__PURE__ */ P({
  __name: "tagPopupListItem",
  props: /* @__PURE__ */ N({
    editable: { type: Boolean },
    disabled: { type: Boolean },
    canExclude: { type: Boolean },
    id: {},
    colorId: {},
    name: {},
    state: {}
  }, {
    name: {
      required: !0
    },
    nameModifiers: {}
  }),
  emits: /* @__PURE__ */ N(["update:name", "unselect", "exclude", "select"], ["update:name"]),
  setup(t, { emit: a }) {
    const o = t, e = a, i = D(t, "name"), l = F(null), n = E(() => navigator.userAgent.indexOf("Firefox") != -1 ? {
      contenteditable: u.value,
      onpaste: (g) => g.preventDefault()
    } : {}), u = F(!1), f = async () => {
      var g;
      u.value = !0, await Ve(), (g = l.value) == null || g.focus();
    }, h = () => {
      var d;
      const g = (d = l.value) == null ? void 0 : d.innerText;
      if (!g) return S();
      l.value && (l.value.innerText = g), u.value = !1, e("update:name", g);
    }, S = async () => {
      l.value && (l.value.innerText = o.name), u.value = !1;
    }, r = (g) => {
      if (u.value || o.disabled) return;
      let d = "selected";
      o.canExclude && (g.ctrlKey || g.metaKey) && (d = "excluded"), o.state == d && (d = ""), d === "" && e("unselect"), d === "selected" && e("select"), d === "excluded" && e("exclude");
    };
    return (g, d) => (k(), b(ue, {
      class: X({
        "top-tagSelector_tagListItem": !0,
        "top-tagSelector_tagListItem-inEdit": u.value,
        "top-tagSelector_tagListItem-disabled": g.disabled,
        "top-tagSelector_tagListItem-canExclude": g.canExclude,
        "top-tagSelector-active": !!g.state,
        "top-tagSelector-excluded": g.state === "excluded"
      }),
      onClick: z(r, ["stop"])
    }, {
      default: _(() => [
        A(ne, {
          id: g.id,
          name: i.value,
          colorId: g.colorId,
          state: g.state
        }, null, 8, ["id", "name", "colorId", "state"]),
        he("span", Se({
          ref_key: "elName",
          ref: l,
          class: "top-tagSelector_tagListItemName",
          contenteditable: u.value ? "plaintext-only" : !1
        }, n.value, {
          onKeydown: [
            de(z(h, ["stop"]), ["enter"]),
            de(z(S, ["stop"]), ["esc"])
          ]
        }), K(i.value), 17, it),
        g.editable ? (k(), B(Y, { key: 0 }, [
          u.value ? (k(), B("span", {
            key: 1,
            "data-top-icon": "",
            class: "top-tagSelector_edit",
            onClick: z(h, ["stop"])
          })) : (k(), B("span", {
            key: 0,
            "data-top-icon": "",
            class: "top-tagSelector_edit",
            onClick: f
          }))
        ], 64)) : q("", !0)
      ]),
      _: 1
    }, 8, ["class"]));
  }
}), st = { key: 1 }, Te = /* @__PURE__ */ P({
  inheritAttrs: !1,
  __name: "popupOpener",
  props: /* @__PURE__ */ N({
    modelValue: {},
    id: {},
    tags: {},
    mode: {},
    targetId: {},
    filters: {},
    useTopButton: { type: Boolean },
    payload: {},
    styling: {}
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(t) {
    const a = t, o = D(t, "modelValue"), e = a.useTopButton ? H : "div", i = a.useTopButton ? "html" : "default", l = {
      model: o,
      mode: a.mode,
      targetId: a.targetId,
      filters: a.filters,
      payload: a.payload
    };
    return (n, u) => {
      const f = Ee("top-data");
      return k(), b(Oe, { id: n.id }, {
        default: _(() => [
          Me((k(), b(Ke(y(e)), Se({
            class: {
              "top-tagSelector": !0,
              "top-tagSelector-filter": a.mode === "filter",
              "top-tagSelector-setter_single": a.mode === "setter" && !n.filters,
              "top-tagSelector-setter_several": a.mode === "setter" && n.filters,
              "top-tagSelector-selectedOne": !o.value.length || o.value.length === 1,
              "top-tagSelector-toTwoLine": o.value.length > 5
            },
            color: "theme",
            styling: n.styling
          }, n.$attrs), {
            [y(i)]: _(() => [
              !o.value.length && n.mode === "filter" ? (k(), b(ne, {
                key: 0,
                id: "all",
                colorId: "",
                name: n.$i18n.Common.All_tags ?? "",
                state: ""
              }, null, 8, ["name"])) : q("", !0),
              n.mode === "setter" && n.filters ? (k(), B("div", st, [
                $e(n.$slots, "default")
              ])) : (k(!0), B(Y, { key: 2 }, se(o.value, (h) => {
                var S, r;
                return k(), b(ne, {
                  id: y(Q)(h),
                  colorId: ((S = y(ae)(h, n.tags)) == null ? void 0 : S.color_id) ?? "",
                  name: ((r = y(ae)(h, n.tags)) == null ? void 0 : r.name) ?? "",
                  state: y(Q)(h) === h ? "selected" : "excluded"
                }, null, 8, ["id", "colorId", "name", "state"]);
              }), 256))
            ]),
            _: 2
          }, 1040, ["class", "styling"])), [
            [f, l, "topTagSelectorTarget"]
          ])
        ]),
        _: 3
      }, 8, ["id"]);
    };
  }
}), ut = /* @__PURE__ */ P({
  __name: "tagSelector",
  props: /* @__PURE__ */ N({
    modelValue: {},
    tags: {},
    tagsEditable: { type: Boolean },
    tagsMax: { default: 10 },
    id: {},
    singleMode: { type: Boolean },
    requiredForSetter: { type: Boolean, default: !0 },
    maxTagsForSetter: {},
    emitDelay: { default: 500 },
    styling: {}
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {},
    tags: {
      default: Ae(ot)
    },
    tagsModifiers: {}
  }),
  emits: /* @__PURE__ */ N(["selector", "setter", "tagsChanged"], ["update:modelValue", "update:tags"]),
  setup(t, { emit: a }) {
    const o = R(), e = t, i = D(t, "modelValue"), l = D(t, "tags"), n = a, u = Re((s, c) => {
      n(s, c);
    }, e.emitDelay);
    e.singleMode && !i.value.length && (i.value = [l.value[0].id]);
    const f = e.id ?? "top-popup-id-" + Math.random(), h = F("add"), S = () => {
      var v;
      const s = " " + ((v = o.Common.Tags) == null ? void 0 : v.toLowerCase()), c = /* @__PURE__ */ new Map();
      return c.set("add", { value: "add", title: o.Common.Add + s }), c.set("replace", { value: "replace", title: o.Common.Replace + s }), c.set("delete", { value: "delete", title: o.Common.Delete + s }), c;
    };
    let r = we({
      model: i,
      mode: "filter",
      targetId: void 0,
      filters: void 0,
      payload: void 0
    });
    w(i, () => {
      u("selector", i.value);
    });
    const g = E(() => {
      if (r.value.mode === "setter" && e.maxTagsForSetter && !r.value.filters)
        return r.value.model.value.length >= e.maxTagsForSetter;
    }), d = (s) => {
      if (s !== "all") {
        if (r.value.model.value.includes(s)) return "selected";
        if (r.value.model.value.includes(ve(s))) return "excluded";
      }
      return s === "all" && !r.value.model.value.length ? "selected" : "";
    }, x = (s, c) => {
      const v = ve(s);
      let I = r.value.model.value.filter((L) => L !== s && L !== v);
      c === "select" && I.push(s), c === "exclude" && I.push(v), r.value.mode === "setter" && r.value.targetId !== void 0 && e.requiredForSetter && (I.length || I.push("1"), I.length === 2 && r.value.model.value.length === 1 && r.value.model.value[0] === "1" && (I = I.filter((L) => L !== "1"))), e.singleMode && !r.value.filters && (I.length || (I = r.value.model.value), I.length > 1 && (I = [I[I.length - 1]])), I.sort((L, U) => {
        if (!e.tags) return 0;
        const Z = e.tags.findIndex((O) => O.id === L), j = e.tags.findIndex((O) => O.id === U);
        return Z - j;
      }), r.value.model.value = I, r.value.mode === "setter" && r.value.targetId !== void 0 && u("setter", {
        tagsIds: I,
        targetId: r.value.targetId,
        payload: r.value.payload
      });
    }, T = E(() => {
      let s = "top-tagSelector_popup";
      return r.value.mode === "filter" && (s += " top-tagSelector_popup-filter"), r.value.mode === "setter" && (s += " top-tagSelector_popup-setter"), s;
    }), C = () => {
      const s = prompt("", "New tag");
      if (!s || s === "New tag") return;
      const c = l.value.length + 1;
      l.value.push({
        id: String(c),
        name: s,
        color_id: String((c - 1) % 10 + 1)
      }), n("tagsChanged", l.value);
    }, V = (s) => {
      var c;
      if (r.value = W(s.elPopupOpener, "topTagSelectorTarget"), !r.value) throw new Error("Open popup TopTagSelector required v-data:topTagSelectorTarget");
      if (r.value.filters && (h.value = "add", r.value.model.value = []), !((c = J.$) != null && c.ui.sortable)) {
        console.info("Для работы сортировки требуется глобальная загрузка jQuery UI Sortable");
        return;
      }
      !J.state.isMobile && !J.state.isMobileUA && l.value && $(s.elPopup).sortable({
        items: 'li:has([data-tag_id]:not([data-tag_id="all"]))',
        /**
         * @todo Удалить `[contenteditable="true"]` через пол года после выхода версии firefox с поддержкой contenteditable plaintext-only, включая бета версии
         */
        cancel: '[contenteditable="plaintext-only"], [contenteditable="true"]',
        distance: 10,
        stop: function(v, I) {
          if (!l.value) return;
          const L = $(I.item).parent().find("[data-tag_id]"), U = [];
          L.each((Z, j) => {
            if (!l.value) return;
            const O = $(j).attr("data-tag_id");
            U.push(O);
          }), l.value.sort((Z, j) => {
            const O = U.findIndex((oe) => oe === Z.id), _e = U.findIndex((oe) => oe === j.id);
            return O - _e;
          }), u("tagsChanged", l.value);
        }
      });
    }, m = (s) => {
      var c;
      (c = J.$) != null && c.ui.sortable && $(s.elPopup).data("ui-sortable") && $(s.elPopup).sortable("destroy");
    };
    return (s, c) => (k(), B(Y, null, [
      A(Te, {
        class: "top-select_arrow",
        modelValue: i.value,
        "onUpdate:modelValue": c[0] || (c[0] = (v) => i.value = v),
        id: y(f),
        tags: l.value,
        styling: s.styling,
        mode: "filter",
        useTopButton: ""
      }, null, 8, ["modelValue", "id", "tags", "styling"]),
      A(Ie, {
        id: y(f),
        class: X(T.value),
        onOpen: c[4] || (c[4] = (v) => V(v)),
        onClose: c[5] || (c[5] = (v) => m(v)),
        "transition-duration": 50
      }, Le({
        contentList: _(() => [
          y(r).mode === "filter" && !s.singleMode ? (k(), b(ye, {
            key: 0,
            id: "all",
            colorId: "",
            name: s.$i18n.Common.All_tags ?? "",
            state: y(r).model.value.length ? "" : "selected",
            onSelect: c[3] || (c[3] = (v) => y(r).model.value = [])
          }, null, 8, ["name", "state"])) : q("", !0),
          (k(!0), B(Y, null, se(l.value, (v) => (k(), b(ye, {
            key: v.id,
            id: v.id,
            colorId: v.color_id,
            name: v.name,
            state: d(v.id),
            canExclude: y(r).mode === "filter" && !s.singleMode,
            editable: s.tagsEditable,
            disabled: g.value && d(v.id) === "",
            onUnselect: (I) => x(v.id, "unselect"),
            onSelect: (I) => x(v.id, "select"),
            onExclude: (I) => x(v.id, "exclude"),
            "onUpdate:name": (I) => {
              v.name = I, y(u)("tagsChanged", l.value);
            }
          }, null, 8, ["id", "colorId", "name", "state", "canExclude", "editable", "disabled", "onUnselect", "onSelect", "onExclude", "onUpdate:name"]))), 128)),
          s.tagsEditable && l.value.length < s.tagsMax && l.value.length < 20 ? (k(), b(ue, {
            key: 1,
            "data-top-icon": "",
            onClick: z(C, ["stop"])
          }, {
            default: _(() => [
              G(K(s.$i18n.Common.Add), 1)
            ]),
            _: 1
          })) : q("", !0)
        ]),
        _: 2
      }, [
        y(r).mode === "setter" && y(r).filters ? {
          name: "header",
          fn: _(() => [
            A(ie, {
              modelValue: h.value,
              "onUpdate:modelValue": c[1] || (c[1] = (v) => h.value = v),
              options: S()
            }, null, 8, ["modelValue", "options"])
          ]),
          key: "0"
        } : void 0,
        y(r).mode === "setter" && y(r).filters ? {
          name: "footer",
          fn: _(() => [
            A(H, { color: "theme" }, {
              default: _(() => [
                G(K(s.$i18n.Common.Cancel), 1)
              ]),
              _: 1
            }),
            A(H, {
              onClick: c[2] || (c[2] = (v) => y(u)("setter", {
                tagsIds: y(r).model.value,
                filters: y(r).filters,
                filtersAction: h.value,
                payload: y(r).payload
              }))
            }, {
              default: _(() => [
                G(K(h.value === "add" ? s.$i18n.Common.Add : "") + " " + K(h.value === "replace" ? s.$i18n.Common.Replace : "") + " " + K(h.value === "delete" ? s.$i18n.Common.Remove : ""), 1)
              ]),
              _: 1
            })
          ]),
          key: "1"
        } : void 0
      ]), 1032, ["id", "class"])
    ], 64));
  }
}), St = (t, a) => E(() => ce(t).filter((i) => i.on >= 0 || i.id === a).map((i) => ({
  value: i.id,
  title: i.url + ` [${i.id}]`,
  icon: i.id === ce(a) ? "" : "",
  content: i.name
}))), It = (t, a, o) => {
  a || (a = { id: t.id }), a.id = t.id;
  const e = Ue.genElPopupOpener("div", a);
  return e.classList.add("top-tagSelector"), t.useTopButton && e.classList.add("top-button", "top-color_theme"), t.mode === "filter" && e.classList.add("top-tagSelector-filter"), t.mode === "setter" && !t.filters && e.classList.add("top-tagSelector-setter_single"), t.mode === "setter" && t.filters && e.classList.add("top-tagSelector-setter_several"), e.onclick = (i) => {
    i.preventDefault(), i.stopPropagation(), e.onclick = null;
    const l = F(t.modelValue), n = {
      model: l,
      mode: t.mode,
      targetId: t.targetId,
      filters: t.filters,
      payload: t.payload
    };
    W(e, "topTagSelectorTarget", n), delete e.dataset.topPopupDisabled, ge(t.modelValue) || w(l, () => {
      t.modelValue = l.value, ee(e, t, o);
    }), e.click();
  }, ge(t.modelValue) ? w(t.modelValue, () => ee(e, t, o)) : W(e, "topTagSelectorRender", (i) => {
    t.modelValue = i;
    const l = W(e, "topTagSelectorTarget");
    l && (l.model.value = i), ee(e, t, o);
  }), ee(e, t, o), e;
}, xt = (t, a) => {
  var o;
  (o = W(t, "topTagSelectorRender")) == null || o(a);
}, ee = (t, a, o) => {
  var i;
  const e = y(a.modelValue);
  if (t.classList.toggle("top-tagSelector-selectedOne", !e.length || e.length === 1), t.classList.toggle("top-tagSelector-toTwoLine", e.length > 5), a.mode === "setter" && a.filters) {
    t.innerHTML = `<div>${o}</div>`;
    return;
  }
  if (t.innerHTML = "", !e.length && a.mode === "filter") {
    const l = pe({
      id: "all",
      colorId: "",
      name: ((i = R().Common) == null ? void 0 : i.All_tags) ?? "",
      state: ""
    });
    t.append(l);
  }
  e.forEach((l) => {
    var u, f;
    const n = pe({
      id: Q(l),
      colorId: ((u = ae(l, a.tags)) == null ? void 0 : u.color_id) ?? "",
      name: ((f = ae(l, a.tags)) == null ? void 0 : f.name) ?? "",
      state: Q(l) === l ? "selected" : "excluded"
    });
    t.append(n);
  });
}, pe = (t) => {
  const a = document.createElement("div");
  return a.classList.add("top-tagSelector_tagIcon"), a.classList.toggle("top-tagSelector-active", !!t.state), a.classList.toggle("top-tagSelector-excluded", t.state === "excluded"), a.dataset.tag_id = t.id, a.dataset.tag_color_id = t.colorId, a.title = t.name, a;
}, kt = Je, Ct = nt, Tt = ut, _t = Te, bt = ne;
export {
  kt as TopSelectorCompetitors,
  Ct as TopSelectorRegion,
  Tt as TopTagSelector,
  _t as TopTagSelectorPopupOpener,
  bt as TopTagSelectorTagIcon,
  Ze as dialogSelectorRegions,
  Xe as findRegion,
  It as genElTopTagSelectorPopupOpener,
  ke as genSearcherByKey,
  xt as renderElTopTagSelectorPopupOpener,
  St as useItemsFromCompetitors
};
//# sourceMappingURL=project.js.map
