import { ComputedRef, Ref } from 'vue';
import { Item, Props } from '../types';
import { API } from './useAPI';
/**
 * Функционал поиска
 */
export declare const useMenu: (model: Ref<Props["modelValue"]>, items: Ref<Props["items"]>, multiselect: Props["multiselect"], appendAllValue: Ref<Props["appendAllValue"]>, appendSearchToResult: Ref<Props["appendSearchToResult"]>, api: API) => {
    searchText: Ref<string, string>;
    resetSearch: () => void;
    items: ComputedRef<Item[]>;
    itemsForShow: ComputedRef<Item[]>;
};
