import { Core as Y } from "../core/app.js";
import { defineComponent as B, ref as w, computed as F, createElementBlock as f, openBlock as p, normalizeClass as C, createCommentVNode as k, createElementVNode as I, toDisplayString as $, createVNode as P, withKeys as L, withModifiers as M, createBlock as A, createSlots as N, withCtx as V, createTextVNode as S, watch as E, toRef as z, mergeProps as W, mergeModels as R, useModel as U, Fragment as _, renderList as G, withDirectives as X, vModelRadio as Q, resolveDirective as Z, unref as b, renderSlot as D } from "vue";
import { w as q, _ as H, f as x, d as ee, u as oe, C as te, x as le } from "../.chunks/forms-C-fyoosd.es.js";
import { TopPopup as se, TopPopupListItem as O, TopPopupWidgetInput as ae } from "../popup/popup.js";
import { invertKeyboardLayout as re } from "../utils/keyboard.js";
import { _ as ne } from "../.chunks/menu.vue_vue_type_style_index_0_lang-Bi9Z81pC.es.js";
const j = ["../assets/formsExt.css"].map((s) => import.meta.resolve(s));
Y.insertCSSLinkToPage(j, !0);
const ie = { class: "top-editArea_footer" }, ue = /* @__PURE__ */ B({
  __name: "editArea",
  props: {
    defaultValue: { default: "" },
    title: {},
    cancelText: { default: "Cancel" },
    submitText: { default: "Send" },
    closeText: { default: "Close" },
    isFocused: { type: Boolean },
    forceShowCloseBtn: { type: Boolean },
    attachToKeyboard: { type: Boolean },
    modelValue: {},
    name: {},
    placeholder: {},
    styling: {},
    rows: {},
    minHeight: {},
    expandable: { type: Boolean, default: !0 },
    disabled: { type: Boolean },
    readonly: { type: Boolean },
    isError: { type: Boolean },
    hint: {},
    maxLength: {}
  },
  emits: ["submit", "close", "clickOnTitle"],
  setup(s, { emit: o }) {
    const e = s, a = o, n = w(e.defaultValue), t = w(e.isFocused), d = F(() => n.value !== e.defaultValue), c = (i) => {
      a("submit", i), n.value = e.defaultValue;
    }, y = () => {
      if (e.forceShowCloseBtn && !d.value) {
        a("close");
        return;
      }
      n.value = e.defaultValue;
    }, g = () => {
      e.attachToKeyboard && a("clickOnTitle");
    };
    return (i, m) => (p(), f("div", {
      class: C({
        "top-editArea": !0,
        "top-editArea-attachedToKeyboard": i.attachToKeyboard
      })
    }, [
      i.title ? (p(), f("div", {
        key: 0,
        class: "top-editArea_title",
        onClick: m[0] || (m[0] = (r) => g())
      }, $(i.title), 1)) : k("", !0),
      I("div", {
        class: C({
          "top-editArea_form": !0,
          "top-error": i.isError,
          "top-focus": t.value
        })
      }, [
        P(q, {
          modelValue: n.value,
          "onUpdate:modelValue": m[1] || (m[1] = (r) => n.value = r),
          name: i.name,
          placeholder: i.placeholder,
          rows: i.rows,
          minHeight: i.minHeight,
          expandable: i.expandable,
          disabled: i.disabled,
          readonly: i.readonly,
          isError: i.isError,
          hint: i.hint,
          class: "top-editArea_element",
          onFocus: m[2] || (m[2] = () => t.value = !0),
          onBlur: m[3] || (m[3] = () => t.value = !1),
          onKeyup: [
            L(y, ["esc"]),
            m[4] || (m[4] = L(M((r) => c(n.value), ["ctrl"]), ["enter"]))
          ]
        }, null, 8, ["modelValue", "name", "placeholder", "rows", "minHeight", "expandable", "disabled", "readonly", "isError", "hint"]),
        I("div", ie, [
          d.value || i.forceShowCloseBtn ? (p(), A(H, {
            key: 0,
            icon: i.$core.state.isMobile ? "" : "",
            class: "top-editArea_button",
            color: "theme",
            styling: "soft",
            onClick: y
          }, N({ _: 2 }, [
            i.$core.state.isMobile ? void 0 : {
              name: "default",
              fn: V(() => [
                S($(i.cancelText), 1)
              ]),
              key: "0"
            }
          ]), 1032, ["icon"])) : k("", !0),
          d.value ? (p(), A(H, {
            key: 1,
            class: "top-editArea_button",
            icon: i.$core.state.isMobile ? "" : "",
            onClick: m[5] || (m[5] = (r) => c(n.value))
          }, N({ _: 2 }, [
            i.$core.state.isMobile ? void 0 : {
              name: "default",
              fn: V(() => [
                S($(i.submitText), 1)
              ]),
              key: "0"
            }
          ]), 1032, ["icon"])) : k("", !0)
        ])
      ], 2)
    ], 2));
  }
}), de = { class: "top-editInput" }, pe = /* @__PURE__ */ B({
  __name: "editInput",
  props: {
    modelValue: {},
    input: {},
    button: {}
  },
  emits: ["update:modelValue"],
  setup(s, { emit: o }) {
    const e = s, a = w(e.modelValue);
    E(z(e.modelValue), () => {
      a.value = e.modelValue;
    });
    const n = o, t = () => {
      n("update:modelValue", a.value);
    };
    return (d, c) => (p(), f("div", de, [
      P(x, W(d.input, {
        onKeydownCapture: c[0] || (c[0] = L(M((y) => a.value = d.modelValue, ["stop"]), ["esc"])),
        onKeydown: L(M(t, ["stop"]), ["enter"]),
        modelValue: a.value,
        "onUpdate:modelValue": c[1] || (c[1] = (y) => a.value = y)
      }), null, 16, ["onKeydown", "modelValue"]),
      a.value !== d.modelValue ? (p(), A(H, W({
        key: 0,
        icon: "",
        styling: "soft"
      }, d.button, { onClick: t }), null, 16)) : k("", !0)
    ]));
  }
}), ce = ["data-top-icon", "onClick"], me = {
  key: 0,
  class: "top-radioGroup_circle"
}, fe = ["value", "disabled"], ve = /* @__PURE__ */ B({
  __name: "radioGroup",
  props: /* @__PURE__ */ R({
    modelValue: {},
    radiosProps: {},
    showIndicator: { type: Boolean },
    size: { default: "s" },
    isError: { type: Boolean }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(s) {
    const o = U(s, "modelValue"), e = s, a = w(null);
    E(o, () => {
      var t, d, c, y, g;
      (t = e.radiosProps) != null && t.some((i) => i.value === o.value) || (o.value = ((c = (d = e.radiosProps) == null ? void 0 : d[0]) == null ? void 0 : c.value) ?? ""), (g = (y = a.value) == null ? void 0 : y.querySelector(".radioGroup_item-selected")) == null || g.scrollIntoView();
    }, { immediate: !0 });
    const n = "radioGroup-" + Math.random();
    return (t, d) => (p(), f("div", {
      ref_key: "elRef",
      ref: a,
      class: C({
        "top-radioGroup": !0,
        "top-scrollBarXHidding": !0,
        ["top-size_" + t.size]: !!t.size,
        "top-error": t.isError
      })
    }, [
      (p(!0), f(_, null, G(t.radiosProps, (c) => (p(), f("label", {
        class: C({
          "top-radioGroup_item-selected": c.value === o.value,
          "top-radioGroup_item": !0,
          "top-forms-focusable": !0,
          "top-disabled": c.disabled
        }),
        "data-top-icon": c.icon,
        onClick: (y) => o.value = c.value
      }, [
        S($(c.title) + " ", 1),
        t.showIndicator ? (p(), f("span", me)) : k("", !0),
        X(I("input", {
          "onUpdate:modelValue": d[0] || (d[0] = (y) => o.value = y),
          name: n,
          type: "radio",
          class: C({
            "top-unvisible": !0
          }),
          value: c.value,
          disabled: c.disabled
        }, null, 8, fe), [
          [Q, o.value]
        ])
      ], 10, ce))), 256))
    ], 2));
  }
}), ye = ["data-top-icon"], he = ["value", "checked", "disabled", "onChange"], be = /* @__PURE__ */ B({
  __name: "checkboxGroup",
  props: /* @__PURE__ */ R({
    modelValue: {},
    items: {},
    size: { default: "s" },
    styling: { default: "outline" },
    isError: { type: Boolean }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(s) {
    const o = U(s, "modelValue"), e = (a) => {
      const n = [...o.value], t = n.indexOf(a);
      t === -1 ? n.push(a) : n.splice(t, 1), o.value = n;
    };
    return (a, n) => (p(), f("div", {
      class: C({
        "top-checkboxGroup": !0,
        ["top-checkboxGroup-" + a.styling]: !0,
        "top-scrollBarXHidding": !0,
        ["top-size_" + a.size]: !!a.size,
        "top-error": a.isError
      })
    }, [
      (p(!0), f(_, null, G(a.items, (t) => (p(), f("label", {
        key: t.id,
        class: C({
          "top-checkboxGroup_item": !0,
          "top-checkboxGroup_item-selected": o.value.includes(t.id),
          "top-forms-focusable": !0,
          "top-disabled": t.disabled
        }),
        "data-top-icon": t.icon
      }, [
        I("input", {
          type: "checkbox",
          class: "top-unvisible",
          value: t.id,
          checked: o.value.includes(t.id),
          disabled: t.disabled,
          onChange: (d) => e(t.id)
        }, null, 40, he),
        S(" " + $(t.title), 1)
      ], 10, ye))), 128))
    ], 2));
  }
}), ge = { class: "top-selector2_itemMulti top-ellipsis" }, ke = /* @__PURE__ */ B({
  __name: "itemMulti",
  props: {
    id: {},
    name: {}
  },
  emits: ["delete"],
  setup(s) {
    return (o, e) => (p(), f("div", ge, [
      S($(o.name) + " ", 1),
      I("span", {
        class: "top-selector2_itemMultiDelete",
        "data-top-icon": "",
        onClick: e[0] || (e[0] = (a) => o.$emit("delete", o.id)),
        onMousedown: e[1] || (e[1] = M(() => {
        }, ["stop"]))
      }, null, 32)
    ]));
  }
}), we = (s, o, e) => {
  const a = w([]), n = w(!1);
  let t = "", d;
  s && !s.params.limit && (s.params.limit = 100);
  const c = async () => {
    if (!s) return;
    let r, v;
    if (e && (s.cache ??= /* @__PURE__ */ new Map(), v = JSON.stringify(s.params), r = s.cache.get(v), r))
      return r;
    if (n.value = !0, r = await s.call(), n.value = !1, r.errors) return;
    if (!Array.isArray(r.result)) {
      console.warn("В result ожидался массив");
      return;
    }
    const l = r.result.findIndex((u) => u.id === void 0 || u.name === void 0);
    if (l !== -1) {
      console.warn(`В result[${l}] нет id или name`);
      return;
    }
    return e && s.cache.set(v, r), r;
  }, y = async () => {
    if (!s) return;
    s.params.offset = 0, s.params.search = t;
    const r = await c();
    r && (d = r.nextOffset, a.value = r.result);
  }, g = async () => {
    if (!s || !d || n.value) return;
    s.params.offset = d, s.params.search = t;
    const r = await c();
    r && (d = r.nextOffset, a.value = a.value.concat(r.result));
  }, i = ee(() => y(), 200);
  return {
    apiRequest: s,
    items: a,
    isLoading: n,
    loadAppend: g,
    setSearchTextAndLoad: (r, v = !0) => {
      s && (r.length < o || r === t && a.value.length || (t = r, v ? i() : y()));
    }
  };
}, Ce = 0, J = (s, o, e = !0) => e && o.id === null ? Array.isArray(s) ? s.some((a) => a.id === o.id && a.name === o.name) : o.name === s.name : Array.isArray(s) ? s.some((a) => a.id === o.id) : o.id === s.id, $e = (s, o, e, a, n, t) => {
  const d = w(""), c = {
    id: Ce,
    name: oe().Common.All
  }, y = () => {
    d.value = "", t.items.value = [];
  }, g = F(() => {
    var r;
    const m = [];
    return !e && a.value && m.push(c), (r = o.value) == null || r.forEach((v) => m.push({ ...v })), m;
  }), i = F(() => {
    const m = d.value.toLowerCase(), r = re(m);
    let v = [];
    return g.value.forEach((l) => {
      const u = l.name.toLowerCase();
      (l.id === Number(m) || u.includes(m) || u.includes(r)) && (u === m || u === r ? v.unshift(l) : v.push(l));
    }), v.push(...t.items.value), n.value && d.value && (!v.length || v[0].name.toLowerCase() !== m) && v.push({
      id: null,
      name: d.value
    }), e && (v = v.filter((l) => !J(s.value, l))), v;
  });
  return {
    searchText: d,
    resetSearch: y,
    items: g,
    itemsForShow: i
  };
}, Te = {
  key: 0,
  class: "top-selector2_activeItems"
}, Ve = {
  key: 1,
  class: "top-selector2_activeName top-ellipsis"
}, Ae = /* @__PURE__ */ B({
  __name: "selector2",
  props: /* @__PURE__ */ R({
    modelValue: {},
    items: { default: () => [] },
    multiselect: { type: Boolean },
    disabled: { type: Boolean },
    size: { default: "s" },
    isError: { type: Boolean },
    apiRequest: {},
    minLength: { default: 0 },
    useCache: { type: Boolean },
    appendSearchToResult: { type: Boolean },
    appendAllValue: { type: Boolean },
    addChanger: { type: Boolean },
    placeholder: {},
    showSelectedInInput: { type: Boolean, default: !0 },
    showSearch: { type: Boolean, default: !0 }
  }, {
    modelValue: { required: !0 },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(s) {
    const o = s, e = U(s, "modelValue"), a = w(null), n = we(o.apiRequest, o.minLength || 0, o.useCache), t = $e(e, z(o, "items"), o.multiselect, z(o, "appendAllValue"), z(o, "appendSearchToResult"), n), d = w(null), c = () => {
      var l;
      return (l = d.value) == null ? void 0 : l.popup;
    }, y = () => {
      if (!Array.isArray(e.value)) {
        const u = (t.itemsForShow.value.findIndex((K) => K.id === e.value.id) + 1) % t.itemsForShow.value.length;
        e.value = { ...t.itemsForShow.value[u] };
      }
    }, g = async (l) => {
      Array.isArray(e.value) && (e.value = e.value.filter((u) => u.id !== l), setTimeout(() => {
        var u;
        (u = c()) == null || u.recalcPosition();
      }));
    }, i = w(!1);
    n.apiRequest && (E(i, () => {
      i.value && n.setSearchTextAndLoad(t.searchText.value, !1);
    }), E(t.searchText, () => n.setSearchTextAndLoad(t.searchText.value)));
    const m = (l) => {
      o.multiselect && Array.isArray(e.value) ? J(e.value, l) || (e.value = [...e.value, l]) : e.value = l;
    }, r = () => {
      var l;
      i.value = !1, (l = a.value) == null || l.focus(), t.searchText.value && t.resetSearch();
    }, v = (l) => {
      const u = l.target;
      u.scrollTop / (u.scrollHeight - u.offsetHeight) > 0.8 && n.loadAppend();
    };
    return window.__STORYBOOK_PREVIEW__ && !o.modelValue && E(
      () => o.multiselect,
      () => {
        e.value = o.multiselect ? [] : { id: null, name: "" };
      },
      { immediate: !0 }
    ), (l, u) => {
      const K = Z("top-focus");
      return p(), A(b(se), {
        ref_key: "popupRef",
        ref: d,
        onOpen: u[3] || (u[3] = (h) => i.value = !0),
        onClose: u[4] || (u[4] = (h) => r()),
        onScrollContentList: u[5] || (u[5] = (h) => l.apiRequest ? v(h) : void 0),
        notch: !1,
        transitionDuration: 0
      }, N({
        opener: V(() => [
          X((p(), f("div", {
            ref_key: "elRef",
            ref: a,
            class: C({
              "top-selector2": !0,
              "top-selector2-multiselect": l.multiselect,
              ["top-size_" + l.size]: !0,
              "top-disabled": l.disabled,
              "top-forms-focusable": !l.disabled,
              "top-error": l.isError
            }),
            onKeydown: [
              u[0] || (u[0] = L(M((h) => h.currentTarget.click(), ["stop", "prevent"]), ["up", "down", "enter", "space"])),
              u[1] || (u[1] = L((h) => e.value = [], ["delete"]))
            ],
            tabindex: "0"
          }, [
            l.multiselect ? (p(), f("div", Te, [
              (p(!0), f(_, null, G(e.value, (h) => (p(), A(ke, {
                id: h.id,
                name: h.name,
                onDelete: g
              }, null, 8, ["id", "name"]))), 256))
            ])) : k("", !0),
            l.multiselect ? k("", !0) : (p(), f("span", Ve, $(Array.isArray(e.value) ? "" : e.value.name), 1)),
            l.addChanger && !l.multiselect && b(t).items.value.length > 1 && !l.disabled ? (p(), f("span", {
              key: 2,
              class: "top-changer top-changer-selector",
              "data-top-popup-disabled": "true",
              onClick: y
            })) : k("", !0)
          ], 34)), [
            [
              K,
              l.isError,
              void 0,
              { onupdate: !0 }
            ]
          ])
        ]),
        contentList: V(() => {
          var h;
          return [
            (p(!0), f(_, null, G(b(t).itemsForShow.value, (T) => (p(), A(b(O), {
              class: C({
                "top-active": !Array.isArray(e.value) && !l.multiselect && e.value.id === T.id && e.value.name === T.name
              }),
              key: T.id ?? void 0,
              closeByClick: !l.multiselect || b(te).state.isMobile,
              onClick: (Ee) => m(T)
            }, {
              default: V(() => [
                l.$slots.item ? D(l.$slots, "item", {
                  key: 0,
                  item: T
                }) : (p(), f(_, { key: 1 }, [
                  S($(T.name), 1)
                ], 64))
              ]),
              _: 2
            }, 1032, ["class", "closeByClick", "onClick"]))), 128)),
            !b(n).isLoading.value && !b(t).itemsForShow.value.length ? (p(), A(b(O), {
              key: 0,
              type: "regular"
            }, {
              default: V(() => [
                S($(l.$i18n.Common.No_results), 1)
              ]),
              _: 1
            })) : k("", !0),
            b(n).isLoading.value && (!l.showSearch || (h = l.apiRequest) != null && h.params.offset) ? (p(), A(b(O), {
              key: 1,
              type: "regular"
            }, {
              default: V(() => [
                P(b(le), { type: "circles" })
              ]),
              _: 1
            })) : k("", !0)
          ];
        }),
        _: 2
      }, [
        l.showSearch ? {
          name: "widget",
          fn: V(() => {
            var h;
            return [
              P(b(ae), {
                title: "Поиск",
                icon: "",
                modelValue: b(t).searchText.value,
                "onUpdate:modelValue": u[2] || (u[2] = (T) => b(t).searchText.value = T),
                isLoading: b(n).isLoading.value && !((h = l.apiRequest) != null && h.params.offset),
                placeholder: !Array.isArray(e.value) && !l.multiselect && l.showSelectedInInput ? e.value.name : l.placeholder
              }, null, 8, ["modelValue", "isLoading", "placeholder"])
            ];
          }),
          key: "0"
        } : void 0
      ]), 1536);
    };
  }
}), Se = ["data-top-icon"], Be = { class: "top-info_text" }, Ie = {
  key: 0,
  class: "top-info_value"
}, Le = /* @__PURE__ */ B({
  __name: "info",
  props: {
    icon: {},
    styling: { default: "default" },
    size: { default: "default" }
  },
  setup(s) {
    return (o, e) => (p(), f("div", {
      class: C({
        "top-info": !0,
        ["top-size_" + o.size]: !0,
        ["top-info-styling_" + o.styling]: !0
      }),
      "data-top-icon": o.icon
    }, [
      I("div", Be, [
        D(o.$slots, "default")
      ]),
      o.$slots.additional ? (p(), f("span", Ie, [
        D(o.$slots, "additional")
      ])) : k("", !0)
    ], 10, Se));
  }
}), Oe = ue, Fe = pe, Ne = ve, De = be, He = Ae, Re = ne, Ue = Le;
export {
  De as TopCheckboxGroup,
  Oe as TopEditArea,
  Fe as TopEditInput,
  Ue as TopInfo,
  Re as TopMenu,
  Ne as TopRadioGroup,
  He as TopSelector2
};
//# sourceMappingURL=formsExt.js.map
